--Texture registering
local surface = AceLibrary("Surface-1.0")

surface:Register("Otravi", "Interface\\AddOns\\RogueStunTimerFu\\Textures\\otravi")
surface:Register("Smooth", "Interface\\AddOns\\RogueStunTimerFu\\Textures\\smooth")
surface:Register("Glaze", "Interface\\AddOns\\RogueStunTimerFu\\Textures\\glaze")
surface:Register("Charcoal", "Interface\\AddOns\\RogueStunTimerFu\\Textures\\Charcoal")
surface:Register("BantoBar", "Interface\\AddOns\\RogueStunTimerFu\\Textures\\default")

--Locals
local L = AceLibrary("AceLocale-2.2"):new("RogueStunTimerFuMenu")
L:RegisterTranslations("enUS", function() return {
	["|cffeda55fCtrl-Alt-Click|r to disable RogueStunTimerFu completely."] = true,
	["RogueStunTimerFu is currently disabled. |cffeda55fClick|r to enable."] = true,
}end)
--Ace2 Registering
RogueStunTimerFu = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceModuleCore-2.0", "FuBarPlugin-2.0")
RogueStunTimerFu:SetModuleMixins("AceEvent-2.0", "CandyBar-2.0")

--Mod Options
RogueStunTimerFu.Menu  = { 
    type ="group",
	--handler = RogueStunTimerFu,
    args = {}
}

RogueStunTimerFu:RegisterChatCommand({"/RogueStunTimerFu", "/rst"}, RogueStunTimerFu.Menu)

--Saved Information
RogueStunTimerFu:RegisterDB("RogueStunTimerFuDB", "RogueStunTimerFuDBPC")

--FuBar Stuff
local tablet = AceLibrary("Tablet-2.0")
RogueStunTimerFu.OnMenuRequest = RogueStunTimerFu.Menu
RogueStunTimerFu.name = "FuBar - RogueStunTimerFu"
RogueStunTimerFu.title = "RogueStunTimerFu"
RogueStunTimerFu.hasNoColor = true
RogueStunTimerFu.hasIcon = "Interface\\AddOns\\Fubar_RogueStunTimerFu\\Icon"
RogueStunTimerFu.defaultMinimapPosition = 180
RogueStunTimerFu.clickableTooltip = false
RogueStunTimerFu.cannotDetachTooltip = true
RogueStunTimerFu.hideWithoutStandby = true


function RogueStunTimerFu:OnTooltipUpdate()
	if RogueStunTimerFu:IsModuleActive("RogueStunTimerFu_Bars")  then
		tablet:SetHint(L["|cffeda55fCtrl-Alt-Click|r to disable RogueStunTimerFu completely."])
	else
		tablet:SetHint(L["RogueStunTimerFu is currently disabled. |cffeda55fClick|r to enable."])
	end
end

function RogueStunTimerFu:OnClick()
	if RogueStunTimerFu:IsModuleActive("RogueStunTimerFu_Bars") then
		if IsControlKeyDown() and IsAltKeyDown() then
			RogueStunTimerFu:ToggleModuleActive("RogueStunTimerFu_Bars")
		end
	else
		RogueStunTimerFu:ToggleModuleActive("RogueStunTimerFu_Bars")
	end

	self:UpdateTooltip()
end 
