assert( RogueStunTimerFu, "RogueStunTimerFu not found!")

local L = AceLibrary("AceLocale-2.2"):new("RogueStunTimerFu_Bars")
L:RegisterTranslations("enUS", function() return {
	["Bars"] = true,
	["bars"] = true,
	["Options for the timer bars."] = true,
	["Show anchor"] = true,
	["anchor"] = true,
	["Show the bar anchor frame."] = true,
	["Scale"] = true,
	["scale"] = true,
	["Set the bar scale."] = true,
	["Grow upwards"] = true,
	["up"] = true,
	["Toggle bars grow upwards/downwards from anchor."] = true,
	["Texture"] = true,
	["Set the texture for the timer bars."] = true,
	["Colors"] = true,
	["Background"] = true,
	["Colors of messages and bars."] = true,
	["Change the bar background color."] = true,
	["Change the bar text color."] = true,
	["player"] = true,
	["Sap"] = true,
	["Distract"] = true,
	["Cheap Shot"] = true,
	["Gouge"] = true,
	["Kidney Shot"] = true,
	["Blind"] = true,
	["Testing..."] = true,
	["Wait! a test!"] = true,
	["Text"] = true,
	["dodged"] = true,
} end)
RogueStunTimerFu_Bars = RogueStunTimerFu:NewModule("RogueStunTimerFu_Bars")
local paint = AceLibrary("PaintChips-2.0")
local minscale, maxscale = 0.25, 2
local surface = AceLibrary("Surface-1.0")

function RogueStunTimerFu_Bars:OnInitialize()
settingsStunTimer = RogueStunTimerFu:AcquireDBNamespace("StunTimer")
    RogueStunTimerFu:RegisterDefaults("StunTimer", "profile", {
	growup = false,
	scale = 1.0,
	texture = "BantoBar",
})
RogueStunTimerFu.Menu.args = {
					[L["anchor"]] = {
						type = "execute",
						order = 1,
						name = L["Show anchor"],
						desc = L["Show the bar anchor frame."],
						func = function() RogueStunTimerFu_Bars:RogueStunTimerFu_ShowAnchors() end,
					},
					[L["up"]] = {
						type = "toggle",
						order = 2,
						name = L["Grow upwards"],
						desc = L["Toggle bars grow upwards/downwards from anchor."],
						get = function() return settingsStunTimer.profile.growup end,
						set = function(v) settingsStunTimer.profile.growup = v end,
						message = "Bars now grow %2$s",
						current = "Bars now grow %2$s",
						map = {[true] = "Up", [false] = "Down"},
					},
					[L["scale"]] = {
						type = "range",
						order = 3,
						name = L["Scale"],
						desc = L["Set the bar scale."],
						min = 0.2,
						max = 2.0,
						step = 0.1,
						get = function() return settingsStunTimer.profile.scale end,
						set = function(v) settingsStunTimer.profile.scale = v end,
					},
					[L["Texture"]] = {
						type = "text",
						order = 4,
						name = L["Texture"],
						desc = L["Set the texture for the timer bars."],
						get = function() return settingsStunTimer.profile.texture end,
						set = function(v) settingsStunTimer.profile.texture = v end,
						validate = surface:List(),
					},
				[L["Colors"]] = {
					type = "group",
					order = 5,
					name = L["Colors"],
					desc = L["Colors of messages and bars."],
					args = {
						[L["Background"]] = {
							name = L["Background"],
							type = "color",
							desc = L["Change the bar background color."],
							hasAlpha = true,
							get = function() if settingsStunTimer.profile.bgc then local _, r, g, b = paint:GetRGBPercent(settingsStunTimer.profile.bgc); return r, g, b, settingsStunTimer.profile.bga else return  0, .5, .5, .5 end end,
							set = function(r, g, b, a) local hex = RogueStunTimerFu_Bars:RGBToHex(r, g, b); paint:RegisterHex(hex); settingsStunTimer.profile.bgc = hex; settingsStunTimer.profile.bga = a end,
						},
						[L["Text"]] = {
							name = L["Text"],
							type = "color",
							desc = L["Change the bar text color."],
							get = function() if settingsStunTimer.profile.txtc then local _, r, g, b = paint:GetRGBPercent(settingsStunTimer.profile.txtc); return r, g, b else return 1, 1, 1 end end,
							set = function(r, g, b) local hex = RogueStunTimerFu_Bars:RGBToHex(r, g, b); paint:RegisterHex(hex); settingsStunTimer.profile.txtc = hex end,
			},
		},
	},
}
end

function RogueStunTimerFu_Bars:OnRegister()
	RogueStunTimerFu.Menu.args.StunTimer.Texture.validate = surface:List()
	self:RegisterEvent("Surface_Registered", function()
		RogueStunTimerFu.Menu.args.StunTimer.Texture.validate = surface:List()
	end)
end

function RogueStunTimerFu_Bars:OnEnable()
	if not surface:Fetch(settingsStunTimer.profile.texture) then settingsStunTimer.profile.texture = "BantoBar" end
	self:SetupFrames()
	self:RegisterEvent("RogueStunTimerFu_ShowAnchors")
	self:RegisterEvent("RogueStunTimerFu_HideAnchors")
	self:RegisterEvent("RogueStunTimerFu_StartBar")
	self:RegisterEvent("RogueStunTimerFu_StopBar")
	self:RegisterEvent("UNIT_SPELLCAST_SENT", "spell")
	self:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE", "Skills")
	self:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE", "Skills")
	self:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE", "Skills")
	self:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER", "Gone")
	self:RegisterEvent("CHAT_MSG_SPELL_BREAK_AURA", "Gone")
	if not self:IsEventRegistered("Surface_Registered") then
		self:RegisterEvent("Surface_Registered", function()
			RogueStunTimerFu.Menu.args.StunTimer.Texture.validate = surface:List()
		end)
	end
end

function RogueStunTimerFu_Bars:Gone()
if string.find(arg1, L["Sap"]) then
	RogueStunTimerFu_Bars:RogueStunTimerFu_StopBar(self, L["Sap"])
elseif string.find(arg1, L["Gouge"]) then
	RogueStunTimerFu_Bars:RogueStunTimerFu_StopBar(self, L["Gouge"])
elseif string.find(arg1, L["Cheap Shot"]) then
	RogueStunTimerFu_Bars:RogueStunTimerFu_StopBar(self, L["Cheap Shot"])
elseif string.find(arg1, L["Blind"]) then
	RogueStunTimerFu_Bars:RogueStunTimerFu_StopBar(self, L["Blind"])
elseif string.find(arg1, L["Kidney Shot"]) then
	RogueStunTimerFu_Bars:RogueStunTimerFu_StopBar(self, L["Kidney Shot"])
end
end

function RogueStunTimerFu_Bars:spell()
self.Stuns={Sap=0, KS={}}
if arg1==L["player"] then
	if arg2==L["Sap"] then
		self.Stuns.Sap=arg3		
	elseif arg2==L["Kidney Shot"] then
		self.Stuns.KS.Rank=arg3
		self.Stuns.KS.CP=GetComboPoints()
	end
end
end

function RogueStunTimerFu_Bars:Skills()
local t=self.Stuns
if string.find(arg1, L["dodged"]) then return end
if string.find(arg1, L["Sap"]) then
	RogueStunTimerFu_Bars:Sap(t.Sap)
elseif string.find(arg1, L["Gouge"]) then
	RogueStunTimerFu_Bars:Gouge()
elseif string.find(arg1, L["Cheap Shot"]) then
	RogueStunTimerFu_Bars:CS()
elseif string.find(arg1, L["Blind"]) then
	RogueStunTimerFu_Bars:Blind()
elseif string.find(arg1, L["Distract"]) then
	RogueStunTimerFu_Bars:Distract()
elseif string.find(arg1, L["Kidney Shot"]) then
	RogueStunTimerFu_Bars:KS(t.KS.Rank, t.KS.CP)
end
end

function RogueStunTimerFu_Bars:RGBToHex(r, g, b)
	return format("%02x%02x%02x", r*255, g*255, b*255)
end

function RogueStunTimerFu_Bars:RogueStunTimerFu_ShowAnchors()
	self.frames.anchor:Show()
end

function RogueStunTimerFu_Bars:RogueStunTimerFu_HideAnchors()
	self.frames.anchor:Hide()
end

function RogueStunTimerFu_Bars:RogueStunTimerFu_StartBar(module, text, time, icon, otherc, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10)
	if not text or not time then return end
	local id = "RogueStunTimerFuBar "..text
	local u = settingsStunTimer.profile.growup

	-- yes we try and register every time, we also set the point every time since people can change their mind midbar.
	module:RegisterCandyBarGroup("RogueStunTimerFuGroup")
	module:SetCandyBarGroupPoint("RogueStunTimerFuGroup", u and "BOTTOM" or "TOP", self.frames.anchor, u and "TOP" or "BOTTOM", 0, 0)
	module:SetCandyBarGroupGrowth("RogueStunTimerFuGroup", u)
	
	bc, balpha, txtc = settingsStunTimer.profile.bgc, settingsStunTimer.profile.bga, settingsStunTimer.profile.txtc

	module:RegisterCandyBar(id, time, text, icon, c1, c2, c3, c4, c5, c6, c8, c9, c10)
	module:RegisterCandyBarWithGroup(id, "RogueStunTimerFuGroup")
	module:SetCandyBarTexture( id, surface:Fetch( settingsStunTimer.profile.texture) )
	if bc then module:SetCandyBarBackgroundColor(id, bc, balpha) end
	if txtc then module:SetCandyBarTextColor(id, txtc) end

	module:SetCandyBarScale(id, settingsStunTimer.profile.scale or 1)
	module:SetCandyBarFade(id, .5)
	module:StartCandyBar(id, true)
end

function RogueStunTimerFu_Bars:RogueStunTimerFu_StopBar(module, text)
	if not text then return end
	module:UnregisterCandyBar("RogueStunTimerFuBar "..text)
end

function RogueStunTimerFu_Bars:SetScale(msg, supressreport)
	local scale = tonumber(msg)
	if scale and scale >= minscale and scale <= maxscale then
		settingsStunTimer.profile.scale = scale
		if not supressreport then RogueStunTimerFu:Print("Scale is set to %s", scale) end
	end
end

function RogueStunTimerFu_Bars:ToggleUp(supressreport)
	settingsStunTimer.profile.growup = not settingsStunTimer.profile.growup
	local t = settingsStunTimer.profile.growup
	if not supressreport then RogueStunTimerFu:Print("Bars now grow %s", (t and "Up" or "Down")) end
end


function RogueStunTimerFu_Bars:SetupFrames()
	local f, t

	f, _, _ = GameFontNormal:GetFont()

	self.frames = {}
	self.frames.anchor = CreateFrame("Frame", "RogueStunTimerFuAnchor", UIParent)
	self.frames.anchor.owner = self
	self.frames.anchor:Hide()

	self.frames.anchor:SetWidth(175)
	self.frames.anchor:SetHeight(75)
	self.frames.anchor:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true, tileSize = 16,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
		insets = {left = 4, right = 4, top = 4, bottom = 4},
		})
	self.frames.anchor:SetBackdropBorderColor(.5, .5, .5)
	self.frames.anchor:SetBackdropColor(0,0,0)
	self.frames.anchor:ClearAllPoints()
	self.frames.anchor:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	self.frames.anchor:EnableMouse(true)
	self.frames.anchor:RegisterForDrag("LeftButton")
	self.frames.anchor:SetMovable(true)
	self.frames.anchor:SetScript("OnDragStart", function() this:StartMoving() end)
	self.frames.anchor:SetScript("OnDragStop", function() this:StopMovingOrSizing() this.owner:SavePosition() end)

	self.frames.cfade = self.frames.anchor:CreateTexture(nil, "BORDER")
	self.frames.cfade:SetWidth(169)
	self.frames.cfade:SetHeight(25)
	self.frames.cfade:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.frames.cfade:SetPoint("TOP", self.frames.anchor, "TOP", 0, -4)
	self.frames.cfade:SetBlendMode("ADD")
	self.frames.cfade:SetGradientAlpha("VERTICAL", .1, .1, .1, 0, .25, .25, .25, 1)
	self.frames.anchor.Fade = self.frames.fade

	self.frames.cheader = self.frames.anchor:CreateFontString(nil,"OVERLAY")
	self.frames.cheader:SetFont(f, 14)
	self.frames.cheader:SetWidth(150)
	self.frames.cheader:SetText("Bars")
	self.frames.cheader:SetTextColor(1, .8, 0)
	self.frames.cheader:ClearAllPoints()
	self.frames.cheader:SetPoint("TOP", self.frames.anchor, "TOP", 0, -10)

	self.frames.leftbutton = CreateFrame("Button", nil, self.frames.anchor)
	self.frames.leftbutton.owner = self
	self.frames.leftbutton:SetWidth(40)
	self.frames.leftbutton:SetHeight(25)
	self.frames.leftbutton:SetPoint("RIGHT", self.frames.anchor, "CENTER", -10, -15)
	self.frames.leftbutton:SetScript( "OnClick", function()  RogueStunTimerFu_Bars:Test() end )

	t = self.frames.leftbutton:CreateTexture()
	t:SetWidth(50)
	t:SetHeight(32)
	t:SetPoint("CENTER", self.frames.leftbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	self.frames.leftbutton:SetNormalTexture(t)

	t = self.frames.leftbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.leftbutton)
	self.frames.leftbutton:SetPushedTexture(t)

	t = self.frames.leftbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.leftbutton)
	t:SetBlendMode("ADD")
	self.frames.leftbutton:SetHighlightTexture(t)
	self.frames.leftbuttontext = self.frames.leftbutton:CreateFontString(nil,"OVERLAY")
	self.frames.leftbuttontext:SetFontObject(GameFontHighlight)
	self.frames.leftbuttontext:SetText("Test")
	self.frames.leftbuttontext:SetAllPoints(self.frames.leftbutton)

	self.frames.rightbutton = CreateFrame("Button", nil, self.frames.anchor)
	self.frames.rightbutton.owner = self
	self.frames.rightbutton:SetWidth(40)
	self.frames.rightbutton:SetHeight(25)
	self.frames.rightbutton:SetPoint("LEFT", self.frames.anchor, "CENTER", 10, -15)
	self.frames.rightbutton:SetScript( "OnClick", function() self:RogueStunTimerFu_HideAnchors() end )

	t = self.frames.rightbutton:CreateTexture()
	t:SetWidth(50)
	t:SetHeight(32)
	t:SetPoint("CENTER", self.frames.rightbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	self.frames.rightbutton:SetNormalTexture(t)

	t = self.frames.rightbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.rightbutton)
	self.frames.rightbutton:SetPushedTexture(t)

	t = self.frames.rightbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.rightbutton)
	t:SetBlendMode("ADD")
	self.frames.rightbutton:SetHighlightTexture(t)
	self.frames.rightbuttontext = self.frames.rightbutton:CreateFontString(nil,"OVERLAY")
	self.frames.rightbuttontext:SetFontObject(GameFontHighlight)
	self.frames.rightbuttontext:SetText("Close")
	self.frames.rightbuttontext:SetAllPoints(self.frames.rightbutton)

	self:RestorePosition()
end

function RogueStunTimerFu_Bars:SavePosition()
	local f = self.frames.anchor
	local s = f:GetEffectiveScale()

	settingsStunTimer.profile.posx = f:GetLeft() * s
	settingsStunTimer.profile.posy = f:GetTop() * s
end

function RogueStunTimerFu_Bars:RestorePosition()
	local x = settingsStunTimer.profile.posx
	local y = settingsStunTimer.profile.posy

	if not x or not y then return end

	local f = self.frames.anchor
	local s = f:GetEffectiveScale()

	f:ClearAllPoints()
	f:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", x / s, y / s)
end


function RogueStunTimerFu_Bars:Test()
RogueStunTimerFu_Bars:RogueStunTimerFu_StartBar(self, L["Testing..."], 15)
RogueStunTimerFu_Bars:RogueStunTimerFu_StartBar(self, L["Wait! a test!"], 5)
end